searchNodes=[{"doc":"Main interface for interacting with a MonetDB server. Implemented as a pool of Monet.Connection. Commands such as query/1 check out a Connection from the pool, call query/1 on it, and then check it back in. The pool has a simple backoff implementation in the case of failed connections. The maximum sleep time before trying to reconnect is 4 seconds.","ref":"Monet.html","title":"Monet","type":"module"},{"doc":"By default, the Monet.Result returned from a select will enumerate a list of lists (via the Enumerable protocol or Jason.encode). The behavior can be changed to enumerate or encode to a list of maps: &quot;select id, name from saiyans&quot; |&gt; Monet.query!() |&gt; Monet.as_map() |&gt; Jason.encode() # or Enum.reduce/map/... Note that calling as_map does not change the rows field of the result. It merely configures how the enumeration will operate. So, to get a list of all maps with columns as atoms, one would do: &quot;select id, name from saiyans&quot; |&gt; Monet.query!() |&gt; Monet.as_map(columns: :atoms) |&gt; Enum.list() as_map works on any value returned by query and query!. In the case of an error, the error is simply returned. As such, a safer usage would be: case Monet.as_map(Monet.query(&quot;select id, name from saiyans&quot;)) do {:ok, result} -&gt; ... {:error, err} -&gt; ... end","ref":"Monet.html#as_map/2","title":"Monet.as_map/2","type":"function"},{"doc":"Returns a supervisor child specification for a pool of Monet.Connections.","ref":"Monet.html#child_spec/1","title":"Monet.child_spec/1","type":"function"},{"doc":"Commits the transaction. This can either be called implicitly based on the return value of your transaction fun: Monet.transaction!(fn tx -&gt; .... {:commit, return_value} # or simply {:ok, return_value} end) or explicitly: Monet.transaction!(fn tx -&gt; .... Monet.commit(tx, return_value) end)","ref":"Monet.html#commit/2","title":"Monet.commit/2","type":"function"},{"doc":"","ref":"Monet.html#map/2","title":"Monet.map/2","type":"function"},{"doc":"","ref":"Monet.html#map!/2","title":"Monet.map!/2","type":"function"},{"doc":"","ref":"Monet.html#maps/2","title":"Monet.maps/2","type":"function"},{"doc":"","ref":"Monet.html#maps!/2","title":"Monet.maps!/2","type":"function"},{"doc":"","ref":"Monet.html#pool/1","title":"Monet.pool/1","type":"macro"},{"doc":"","ref":"Monet.html#pool/2","title":"Monet.pool/2","type":"macro"},{"doc":"Creates a prepared statement for use in a transaction. The statements are automatically cleaned up at the end of the transaction. Use with care. MonetDB automatically deallocates prepared statements on execution error. If a query using a prepared statement fails in your transaction you should probably end the transaction. Monet.transaction(fn tx -&gt; Monet.prepare(tx, :test_insert, &quot;insert into test (id) values (?)&quot;) with {:ok, r1} &lt;- Monet.query(tx, :test_insert, [1]), {:ok, r2} &lt;- Monet.query(tx, :test_insert, [2]) do {:ok, [r1, r2]} else err -&gt; {:rollback, err} end end)","ref":"Monet.html#prepare/3","title":"Monet.prepare/3","type":"function"},{"doc":"","ref":"Monet.html#prepare!/3","title":"Monet.prepare!/3","type":"function"},{"doc":"Executes a query. Returns {:ok, %Monet.Result{}} or {:error, %Monet.Error{}} If no pool name is given, then the default name, Monet, is used. If no arguments are given, then a simple query is executed, otherwise, the query is prepared + executed + deallocated.","ref":"Monet.html#query/1","title":"Monet.query/1","type":"function"},{"doc":"","ref":"Monet.html#query/2","title":"Monet.query/2","type":"function"},{"doc":"","ref":"Monet.html#query/3","title":"Monet.query/3","type":"function"},{"doc":"Same as query but returns a %Monet.Result{} or raises a %Monet.Error{}.","ref":"Monet.html#query!/1","title":"Monet.query!/1","type":"function"},{"doc":"","ref":"Monet.html#query!/2","title":"Monet.query!/2","type":"function"},{"doc":"","ref":"Monet.html#query!/3","title":"Monet.query!/3","type":"function"},{"doc":"Rollsback the transaction. This can either be called implicitly based on the return value of your transaction fun: Monet.transaction!(fn tx -&gt; .... {:rollback, return_value} end) or explicitly: Monet.transaction!(fn tx -&gt; .... Monet.rollback(tx, return_value) end)","ref":"Monet.html#rollback/2","title":"Monet.rollback/2","type":"function"},{"doc":"","ref":"Monet.html#row/1","title":"Monet.row/1","type":"function"},{"doc":"","ref":"Monet.html#row!/1","title":"Monet.row!/1","type":"function"},{"doc":"","ref":"Monet.html#rows/1","title":"Monet.rows/1","type":"function"},{"doc":"","ref":"Monet.html#rows!/1","title":"Monet.rows!/1","type":"function"},{"doc":"","ref":"Monet.html#scalar/1","title":"Monet.scalar/1","type":"function"},{"doc":"","ref":"Monet.html#scalar!/1","title":"Monet.scalar!/1","type":"function"},{"doc":"Starts the pool and establishes the specified number of connections Options :connect_timeout - Timeout, in milliseconds, to conn10_000 :database - Database to conenct to (default: &quot;monetdb&quot;) :host - Hostname or IP of the server to connect to (default:&quot;127.0.0.1&quot;) :name - The process name of the pool (default: Monet) :password - Password to use (default: &quot;monetdb&quot;) :pool_size - Size of the conncetion pool (default: 10) :port - Port of the server to connect to (default: 50_000) :schema - The schema to use (defautls to not sending a &#39;set schema&#39; command (and thus defaults to the user&#39;s defautl schema)) :role - The role to use (defautls to not sending a &#39;set role&#39; command (and thus defaults to the user&#39;s defautl role)) :read_timeout - Timeout, in milliseconds, for individual tcp recv operations (default: 10_000) :send_timeout - Timeout, in milliseconds, for individual tcp send operatins (default: 10_000) :username - Username to use (default: &quot;monetdb&quot;) If a :name is given, that value must be provided as the first parameter to other functions in this module.","ref":"Monet.html#start_link/1","title":"Monet.start_link/1","type":"function"},{"doc":"Checkouts a connection and runs fun within a transaction. If fun returns {:rollback, res}, the transaction is rolled back and {:error, res} is returned. Alternatively, Monet.rollback/2 can be used to the same effect. NOTE: The above means that, unlike other functions which only return {:ok, %Monet.Result{}} or {:error, %Monet.Error{}}, this function can also return {:error, term} where term is any value passed to Monet.rollback/2) or specified via {:rollback, value}. Any other value returned by fun will result in the transaction being committed: Monet.transaction(fn tx -&gt; Monet.query(tx, &quot;....&quot;) Monet.query(tx, &quot;....&quot;) end) To be more explicit, fun can return {:commit, result} in which case the transaction will be commited and {:ok, result} will be returned.","ref":"Monet.html#transaction/2","title":"Monet.transaction/2","type":"function"},{"doc":"Same as query but returns a %Monet.Result{}, raises a %Monet.Error{} or raises whatever custom rollback value you provide.","ref":"Monet.html#transaction!/2","title":"Monet.transaction!/2","type":"function"},{"doc":"Handles authenticating with the MonetDB server. Shouldn&#39;t be called directly. Automatically invoked as part of the connection startup which is managed by the connection pool (the Monet module).","ref":"Monet.Auth.html","title":"Monet.Auth","type":"module"},{"doc":"The monetdbd process can either proxy or redirect us to the actual database server (mserver5). Even when proxying, we&#39;re required to reconnect. In either case, we want to limit how many times we&#39;ll attempt to do so. Currently, this is set to 10 (because that&#39;s what all the other drivers seem to do.)","ref":"Monet.Auth.html#login/3","title":"Monet.Auth.login/3","type":"function"},{"doc":"Represents a connection (a socket) to the MonetDB Server. Although this can be accessed directy (staring with conn/1), the intention is for it to be accessed via the Monet module (which manages a pool of these connections).","ref":"Monet.Connection.html","title":"Monet.Connection","type":"module"},{"doc":"","ref":"Monet.Connection.html#close/1","title":"Monet.Connection.close/1","type":"function"},{"doc":"Connects to the MonetDB server. See Monet.start_link/1 for available options (although some of the options listed there such as pool_size are specific to the Monet pool and not this individual connection).","ref":"Monet.Connection.html#connect/1","title":"Monet.Connection.connect/1","type":"function"},{"doc":"","ref":"Monet.Connection.html#connection/1","title":"Monet.Connection.connection/1","type":"macro"},{"doc":"","ref":"Monet.Connection.html#connection/2","title":"Monet.Connection.connection/2","type":"macro"},{"doc":"In Elixir, every socket is assigned a &quot;controlling&quot; process. This is to control the destination of incoming data when the socket is in active mode. We don&#39;t use active mode (but we might leverage it in the future). Still, it appears that the socket is also tied to the lifetime of the controlling process, so we do have to set this once in Monet.init_worker.","ref":"Monet.Connection.html#controlling_process/2","title":"Monet.Connection.controlling_process/2","type":"function"},{"doc":"Get the name of the pool this connection belongs tos","ref":"Monet.Connection.html#pool_name/1","title":"Monet.Connection.pool_name/1","type":"function"},{"doc":"A query with no arguments is executed as a simple query. A query with arguments is executed as a prepare + exec + deallocate. Query does not mutate the conn, but conn is returned nonetheless (along with the result or error). The returned conn can be nil, which indicates that the connection can no longer be used.","ref":"Monet.Connection.html#query/3","title":"Monet.Connection.query/3","type":"function"},{"doc":"Runs fun in a transaction. Automaticaly starts and commits/rollsback the transaction. When called through the pool (that is via Monet.transaction/1) the connection is automatically closed (and thus the transaction rolledback) on an exception. If calling this directly, it is up to the caller to deal with exceptions.","ref":"Monet.Connection.html#transaction/2","title":"Monet.Connection.transaction/2","type":"function"},{"doc":"A simple query builder. rows = Select.new() |&gt; Select.columns(&quot;u.id, u.name&quot;) |&gt; Select.from(&quot;users u&quot;) |&gt; Select.join(&quot;roles r on u.role_id = r.id&quot;) |&gt; Select.where(&quot;u.power&quot;, :gt, 9000) |&gt; Select.limit(100) |&gt; Select.exec!() // returns a Monet.Result |&gt; Monet.rows()","ref":"Monet.Query.Select.html","title":"Monet.Query.Select","type":"module"},{"doc":"Columns to select. If not called, will select *. Can can called multiple times. Can be called with an array, or a string. This can really be anything and it&#39;s best to think of it as the test that is placed between the select and the `from.","ref":"Monet.Query.Select.html#columns/2","title":"Monet.Query.Select.columns/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#exec/2","title":"Monet.Query.Select.exec/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#exec!/2","title":"Monet.Query.Select.exec!/2","type":"function"},{"doc":"Table to select from. Can be called multiple times. This essentially becomes what gets placed between the &quot;from&quot; and the &quot;where&quot;. You could do: Select.from(s, &quot;users&quot;) # OR Select.from(s, &quot;(select 1 from another) x&quot;)","ref":"Monet.Query.Select.html#from/2","title":"Monet.Query.Select.from/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#group/2","title":"Monet.Query.Select.group/2","type":"function"},{"doc":"Join tables. There&#39;s no magic here. Doesn&#39;t know anything about your tables (aka, you need to tell it what to join on): Select.join(s, &quot;table b on a.id = b.id&quot;) This is just a shorthand for from/2 but it injects the word &quot; [left|right|full]? join &quot; for you","ref":"Monet.Query.Select.html#join/2","title":"Monet.Query.Select.join/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#join/3","title":"Monet.Query.Select.join/3","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#limit/2","title":"Monet.Query.Select.limit/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#new/0","title":"Monet.Query.Select.new/0","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#offset/2","title":"Monet.Query.Select.offset/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#order/2","title":"Monet.Query.Select.order/2","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#order/3","title":"Monet.Query.Select.order/3","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#to_sql/1","title":"Monet.Query.Select.to_sql/1","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#where/4","title":"Monet.Query.Select.where/4","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#where_and/2","title":"Monet.Query.Select.where_and/2","type":"macro"},{"doc":"","ref":"Monet.Query.Select.html#where_ignore_nil/4","title":"Monet.Query.Select.where_ignore_nil/4","type":"function"},{"doc":"","ref":"Monet.Query.Select.html#where_or/2","title":"Monet.Query.Select.where_or/2","type":"macro"},{"doc":"","ref":"Monet.Query.Where.html","title":"Monet.Query.Where","type":"module"},{"doc":"","ref":"Monet.Query.Where.html#eq/3","title":"Monet.Query.Where.eq/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#gt/3","title":"Monet.Query.Where.gt/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#gte/3","title":"Monet.Query.Where.gte/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#like/3","title":"Monet.Query.Where.like/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#lt/3","title":"Monet.Query.Where.lt/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#lte/3","title":"Monet.Query.Where.lte/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#ne/3","title":"Monet.Query.Where.ne/3","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#new/0","title":"Monet.Query.Where.new/0","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#to_sql/1","title":"Monet.Query.Where.to_sql/1","type":"function"},{"doc":"","ref":"Monet.Query.Where.html#where_fun/3","title":"Monet.Query.Where.where_fun/3","type":"function"},{"doc":"Reads and parses responses from the server. Should not be called directly from outside this library.","ref":"Monet.Reader.html","title":"Monet.Reader","type":"module"},{"doc":"Parses the given binary as extract_date. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the extract_date (start position) as {line, column_on_line}. Options :line - the initial line, defaults to 1 :byte_offset - the initial byte offset, defaults to 0 :context - the initial context value. It will be converted to a map","ref":"Monet.Reader.html#extract_date/2","title":"Monet.Reader.extract_date/2","type":"function"},{"doc":"Parses the given binary as extract_time. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the extract_time (start position) as {line, column_on_line}. Options :line - the initial line, defaults to 1 :byte_offset - the initial byte offset, defaults to 0 :context - the initial context value. It will be converted to a map","ref":"Monet.Reader.html#extract_time/2","title":"Monet.Reader.extract_time/2","type":"function"},{"doc":"Parses the given binary as extract_time_zone. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the extract_time_zone (start position) as {line, column_on_line}. Options :line - the initial line, defaults to 1 :byte_offset - the initial byte offset, defaults to 0 :context - the initial context value. It will be converted to a map","ref":"Monet.Reader.html#extract_time_zone/2","title":"Monet.Reader.extract_time_zone/2","type":"function"},{"doc":"Reads a single message","ref":"Monet.Reader.html#message/2","title":"Monet.Reader.message/2","type":"function"},{"doc":"Reads the result from a query","ref":"Monet.Reader.html#result/1","title":"Monet.Reader.result/1","type":"function"},{"doc":"Represents the result from a query to MonetDB. For a select columns are the column names and rows is a list of lists. These can be accessed directly. However, the module also implements Enumerable and Jason.Encode. By default, Enumerationa and Jason.Encode will expose the list of lists as-is. However, the Result can be configured to return a list of maps (optionally with atom keys). See Monet.as_map/1 and Monet.as_map/2 for more information. last_id is non-nil in the case of an insert to a table with an auto incremental column (e.g. serial) and nil in all other cases. row_count represents either the number of affected rows (for an update or delete) or the number of rows (for a select). Responses from the MonetDB server generally include some meta data, such as timing information. This data isn&#39;t useful to this driver, but it&#39;s exposed in in the meta field, in case it&#39;s useful to the caller. This data is unparsed; it&#39;s binary field.","ref":"Monet.Result.html","title":"Monet.Result","type":"module"},{"doc":"Switches the the mode of the result to enumerate or jason encode maps. See Monet.as_map/1 and Monet.as_map/2 for more information.","ref":"Monet.Result.html#as_map/2","title":"Monet.Result.as_map/2","type":"function"},{"doc":"Creates a new Result with only a meta field (the type of result you&#39;d get from a create table, for example)","ref":"Monet.Result.html#meta/1","title":"Monet.Result.meta/1","type":"function"},{"doc":"Creates a new Result from a select or other queries that return data","ref":"Monet.Result.html#new/4","title":"Monet.Result.new/4","type":"function"},{"doc":"Creates a new Result with a count and last_id, used by update/delete/insert","ref":"Monet.Result.html#upsert/3","title":"Monet.Result.upsert/3","type":"function"},{"doc":"Created via Monet.transaction/1 or Monet.transaction/2.","ref":"Monet.Transaction.html","title":"Monet.Transaction","type":"module"},{"doc":"Deallocates any prepared statements that were allocated as part of this transaction","ref":"Monet.Transaction.html#close/1","title":"Monet.Transaction.close/1","type":"function"},{"doc":"Commits the transaction","ref":"Monet.Transaction.html#commit/1","title":"Monet.Transaction.commit/1","type":"function"},{"doc":"","ref":"Monet.Transaction.html#new/1","title":"Monet.Transaction.new/1","type":"function"},{"doc":"Prepares the statement and stores it in the transaction cache. See Monet.prepare/3.","ref":"Monet.Transaction.html#prepare/3","title":"Monet.Transaction.prepare/3","type":"function"},{"doc":"Executes the query using the specific transaction","ref":"Monet.Transaction.html#query/3","title":"Monet.Transaction.query/3","type":"function"},{"doc":"Rollsback the transaction","ref":"Monet.Transaction.html#rollback/1","title":"Monet.Transaction.rollback/1","type":"function"},{"doc":"","ref":"Monet.Transaction.html#transaction/1","title":"Monet.Transaction.transaction/1","type":"macro"},{"doc":"","ref":"Monet.Transaction.html#transaction/2","title":"Monet.Transaction.transaction/2","type":"macro"},{"doc":"Prepares and sends messages to the server. Should not be called directly from outside this library.","ref":"Monet.Writer.html","title":"Monet.Writer","type":"module"},{"doc":"Sends a command to the server. Commands appear to be queries with just an empty response. This should","ref":"Monet.Writer.html#command/2","title":"Monet.Writer.command/2","type":"function"},{"doc":"Encodes a list of value to be sent as part of a prepare + exec flow. The types parameter is parsed from the response of the prepare statement. See Monet.Prepared for more information","ref":"Monet.Writer.html#encode/3","title":"Monet.Writer.encode/3","type":"function"},{"doc":"","ref":"Monet.Writer.html#encode_string/1","title":"Monet.Writer.encode_string/1","type":"function"},{"doc":"Sends a query to the server. Except for a very few things that are considered &quot;commands&quot;, almost everything is a query","ref":"Monet.Writer.html#query/2","title":"Monet.Writer.query/2","type":"function"},{"doc":"Sends data to the server. MonetDB only accepts individual frames up to 8190 bytes. If our message is larger than this, it needs to be broken up. Each frame has a 2 byte header. 1 bit of the header is used to indicate if this is the final frame of the message or not. The rest is used for the length.","ref":"Monet.Writer.html#send/2","title":"Monet.Writer.send/2","type":"function"},{"doc":"Represents an error. The source field is :monetd when the error was returned by the MonetDB server. In such cases the code field should be the integer code returned (though it could be nil in the unlikely case that the error couldn&#39;t be parsed properly). The source field is client when Monet.row, Monet.row!, Monet.map, Monet.map!, Monet.scalar or Monet.scalar! are called on a result with more rows or columns than is expected (e.g., calling Monet.scalar on a result that has more than 1 row or more than 1 column).Monet Otherwise the source field can be either :network or :driver to indicate a tcp-level error or an error arising from this library. In both cases, code will always be nil. The message field contains a human readable description of the problem. It is always present. It&#39;s usually a string, except when source is :tcp it will be an atom. The details field can contain anything, including nil. This is generally set by Monet.Reader on a parsing error to provide some context about the data which could not be parsed.","ref":"Monet.Error.html","title":"Monet.Error","type":"exception"},{"doc":"Turns an Monet.Error into a binary for display","ref":"Monet.Error.html#message/1","title":"Monet.Error.message/1","type":"function"}]